Thank you for reporting your issue!

To be able to better understand you problem or suggestion, please add as much information as possible to this ticket. When there is no or just little information, it will be too difficult to work on it (and hence we will not be able to solve it)

Please fill in the following sections:

### What is the problem
> Describe exactly what you see (e.g. an output of an XQuery) 

### What did you expect
> Describe what you expected to happen. Add for example a reference to a [specification](https://www.w3.org/TR/xquery-3/).

### Describe how to reproduce or add a test
> Describe how we can can reproduce the problem.

> The *best* way is to provide a 'self containing' test, a test that can be run without dependancies. The [XQSuite - Annotation-based Test Framework for XQuery](http://exist-db.org/exist/apps/doc/xqsuite.xml) makes it very easy for you to create tests. These tests can be executed from the [eXide editor](http://exist-db.org/exist/apps/eXide/index.html) (XQuery - Run as Test)

### Context information
Please always add the following information
- eXist-db version + Git Revision hash e.g. eXist-db 3.0 /  acd0c14 
- Java version (e.g. Java8u121)
- Operating system (Windows 7, Linux, MacOs)
- 32 or 64 bit
- How is eXist-db installed? (JAR installer, DMG, WAR file, clone from GitHub)
- Any custom changes in e.g. conf.xml
